# Preview for Jumping Moves!!!

keys = {'C': 5, 'B': 4, 'A': 6}

class Move:
	def __init__(self, text, type, name):
		self.text = text
		self.type = type
		self.name = name
	def install(self, d):
		d['{{{OURNEWMOVE}}}'] += self.text+'\n'
		if self.type == 'jump':
			d['{{{ROUTINEJUMPCALL}}}'] += "bsr.w "+self.name+'\n\t'
		elif self.type == 'air':
			d['{{{ROUTINEAIRCALL}}}'] += "bsr.w "+self.name+'\n\t'
		elif self.type == 'roll':
			d['{{{ROUTINEROLLCALL}}}'] += "bsr.w "+self.name+'\n\t'
		elif self.type == 'stand':
			d['{{{ROUTINESTANDCALL}}}'] += "bsr.w "+self.name+'\n\t'		

def makeMove():
	if moveforwards:
		if type in ['jump', 'air']:
			DIRECTION = 10
			ANTDIRECTION = 12
		else:
			DIRECTION = 14
			ANTDIRECTION = 16
		CHECKDIR="""{MNAME}_ChkDirection:
\tbtst	#0,$22(a0)		; is sonic facing left?
\tbeq.s	{MNAME}_MovePlayer			; if yes, branch
\tneg.w	d0			; if not, negate d0 (for jumping to the right)""".replace('{MNAME}', OURNEWMOVENAME)
	elif moveright:
		if type in ['jump', 'air']:
			DIRECTION = 10
			ANTDIRECTION = 12
		else:
			DIRECTION = 14
			ANTDIRECTION = 16
		CHECKDIR="""{MNAME}_ChkDirection:
\tneg.w	d0			; negate d0 (for jumping to the right)""".replace('{MNAME}', OURNEWMOVENAME)
	elif moveleft:
		if type in ['jump', 'air']:
			DIRECTION = 10
			ANTDIRECTION = 12
		else:
			DIRECTION = 14
			ANTDIRECTION = 16
		CHECKDIR = ""
	elif movedown:
		if type in ['jump', 'air']:
			DIRECTION = 12
			ANTDIRECTION = 10
		else:
			DIRECTION = 16
			ANTDIRECTION = 14
		CHECKDIR = ""
	elif moveup:
		if type in ['jump', 'air']:
			DIRECTION = 12
			ANTDIRECTION = 10
		else:
			DIRECTION = 16
			ANTDIRECTION = 14
		CHECKDIR="""{MNAME}_ChkDirection:
\tneg.w	d0			; negate d0 (for jumping down)""".replace('{MNAME}', OURNEWMOVENAME)
	else:
		CHECKDIR="""{MNAME}_ChkDirection:
\tneg.w	d0			; negate d0 (for jumping down)""".replace('{MNAME}', OURNEWMOVENAME)
		
	if sound:
		soundPlay = """move.w	#${SOUND}+$80,d0			; set sound
\tjsr	(PlaySound).l		; play sound""".replace('{SOUND}', sound)
	else:
		soundPlay = ""
			
	if dotwice:
		TESTFLAGPROCEDURE = ''
		CLEARFLAGPROCEDURE = ''
	else:
		TESTFLAGPROCEDURE = """tst.b	($FFFFFFEB).w		; was the move flag set?
\tbne.w	{MNAME}_End			; if yes, branch
\tmove.b	#1,($FFFFFFEB).w	; if not, set move flag""".replace('{MNAME}', OURNEWMOVENAME)
		CLEARFLAGPROCEDURE = "bclr	#4,$22(a0)		; clear move flag"

	if minusrings:
		takeRings = """cmpi.w	#{RINGS},(Ring_count).w	; does Sonic have at least {RINGS} rings?
\tbcs.s	{MNAME}_End		; if not, branch
\tsubq.w	#{RINGS},(Ring_count).w ; Subtract {RINGS} rings.
\tori.b	#$80,(Update_HUD_rings).w ; Update the HUD.""".replace('{RINGS}', `minusrings`).replace('{MNAME}', OURNEWMOVENAME)
	else:
		takeRings = ""
		
	theProcedure = """
; ---------------------------------------------------------------------------
; Subroutine to perform a NEW move!!!!!!!!
; ---------------------------------------------------------------------------

{MNAME}:
	btst	#{KEY},(Ctrl_1_Press).w
	beq.w	{MNAME}_End	; If not, branch
	{TESTFLAG}
	{TAKERINGS}
	{SOUNDPLAY}
	{CLEARFLAG}
	move.w	#${SPEED},d0	; set the speed to d0

	{CHECKDIR}

	{MNAME}_MovePlayer:
		move.w	d0,${DIRECTION}(a0)	; Move Sonic...
		{CLEAROTHER}

	{MNAME}_End:
		rts				; return
	; End of function {MNAME}"""

	theProcedure = theProcedure.replace('{MNAME}', OURNEWMOVENAME)

	theProcedure = theProcedure.replace('{KEY}', `keys[keyPress]`)

	theProcedure = theProcedure.replace('{TESTFLAG}', TESTFLAGPROCEDURE)

	theProcedure = theProcedure.replace('{CLEARFLAG}', CLEARFLAGPROCEDURE)

	theProcedure = theProcedure.replace('{SOUNDPLAY}', soundPlay)
	
	if takeRings:
		theProcedure = theProcedure.replace('{TAKERINGS}', takeRings)
	else:
		theProcedure = theProcedure.replace('{TAKERINGS}', '')
		
	theProcedure = theProcedure.replace('{SPEED}', `moveSpeed`)

	theProcedure = theProcedure.replace('{CHECKDIR}', CHECKDIR)

	theProcedure = theProcedure.replace('{DIRECTION}', `DIRECTION`)

	co = """clr.w	${ANTDIRECTION}(a0)	; Stop Sonic's velocity in the other direction...""".replace('{ANTDIRECTION}', `ANTDIRECTION`)
	if not clearOther: co = ''

	theProcedure = theProcedure.replace('{CLEAROTHER}', co)
	
	return Move(theProcedure, type, OURNEWMOVENAME)

d = {}

d['{{{ROUTINESTANDCALL}}}'] = ""
d['{{{ROUTINEAIRCALL}}}'] = ""
d['{{{ROUTINEROLLCALL}}}'] = ""
d['{{{ROUTINEJUMPCALL}}}'] = ""

RESETFLAGPROCEDURE = "move.b	#0,($FFFFFFEB).w	; reset move flag"
d['{{{RESETMOVEFLAG}}}'] = RESETFLAGPROCEDURE

d['{{{OURNEWMOVE}}}'] = ""

directions = open('moves.txt', 'r').readlines()

for i in directions:
	execfile(i.strip())
	makeMove().install(d)

def makeASM(filename, reset=False):
	if reset:
		for i in d.keys():
			d[i] = ''
			
	try: x = open('backup_'+filename, 'r')
	except: x = open(filename, 'r')
	wds = x.read()
	x.close()
	
	y = open('backup_'+filename, 'w')
	y.write(wds)
	y.close()
	
	for x in d.keys():
		wds = wds.replace(x, d[x])
		
	z = open(filename, 'w')
	z.write(wds)
	z.close()

makeASM('s2.asm')